# Projekt Badawczy - proceduralne tworzenie efektów atmosferycznych 3D przy uzyciu CUDA

Rodzaj projektu badawczego: aplikacyjny
Opiekun projektu: Bartłomiej Mróz
Zgłaszający projekt: Piotr Masiak (Katana Studio)
Edycja projektu badawczego: Projekt badawczy 2024

# Snow Simulation using Material Point Method (MPM) & Marching Cubes in CUDA/C++

This repository contains a GPU-accelerated snow simulation implemented in C++ with CUDA, utilizing the Material Point Method (MPM) for realistic snow dynamics and Marching Cubes for surface reconstruction. The project efficiently handles large-scale simulations by leveraging parallel computing on modern GPUs, making it suitable for and high-quality visual effects.

# Examples

![ball](examples/results/1.png)
![ball](examples/results/2.png)

# Dependencies

* CUDA 12.6
* Eigen 3.4.0
* https://github.com/ericjang/svd3
* https://github.com/nlohmann/json

# License

[![CC BY 4.0][cc-by-shield]][cc-by]

This work is licensed under a
[Creative Commons Attribution 4.0 International License][cc-by].

[![CC BY 4.0][cc-by-image]][cc-by]

[cc-by]: https://creativecommons.org/licenses/by/4.0/
[cc-by-image]: https://i.creativecommons.org/l/by/4.0/88x31.png
[cc-by-shield]: https://img.shields.io/badge/License-CC%20BY%204.0-lightgrey.svg
