#include "Grid.cuh"
//#include "common.cuh"

__host__ __device__ int grid_index_grid(int x, int y, int z) {
    return n_z_grid * n_y_grid * x + n_z_grid * y + z;
}

__host__ __device__ void get_coordinates(int index, int& x, int& y, int& z) {
    z = index % n_z_grid;
    y = (index / n_z_grid) % n_y_grid;
    x = index / (n_z_grid * n_y_grid);
}



__host__ __device__ void get_neighbors(int index, int* neighbors) {

    // przejscie z 1D na 3D
    int x, y, z;
    get_coordinates(index, x, y, z);

    for (int i = 0; i < 6; i++) {
        neighbors[i] = -1;
    }

    int neighbor_idx = 0;

    // X
    if (x > 0) {
        neighbors[neighbor_idx++] = grid_index_grid(x - 1, y, z);
    }
    if (x < n_x_grid - 1) {
        neighbors[neighbor_idx++] = grid_index_grid(x + 1, y, z);
    }

    // Y
    if (y > 0) {
        neighbors[neighbor_idx++] = grid_index_grid(x, y - 1, z);
    }
    if (y < n_y_grid - 1) {
        neighbors[neighbor_idx++] = grid_index_grid(x, y + 1, z);
    }

    // Z
    if (z > 0) {
        neighbors[neighbor_idx++] = grid_index_grid(x, y, z - 1);
    }
    if (z < n_z_grid - 1) {
        neighbors[neighbor_idx++] = grid_index_grid(x, y, z + 1);
    }
}
