#ifndef PARTICLE_H
#define PARTICLE_H

#include "common.cuh"

struct Particle {
    Vector x;
    Vector v;
    Vector a;
    Matrix Fe;
    Matrix Fp;
    Matrix velocity_gradient;
    Precision m;
    Precision V;
    Precision rho;

    Vector weight_gradients[4][4][4];
    Precision weights[4][4][4];

    Particle(Precision x, Precision y, Precision z, Precision vx, Precision vy, Precision vz, Precision rho_0, Precision particle_volume) { // napisac dodatkowy konstruktor z wektorami
        this->x = Vector(x, y, z);
        this->v = Vector(vx, vy, vz);
        this->a = Vector::Zero();
        this->m = rho_0 * particle_volume;
        this->V = 0.0;
        this->rho = 0.0;
        this->Fe = Matrix::Identity();
        this->Fp = Matrix::Identity();
        this->velocity_gradient = Matrix::Zero();

        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                for (int k = 0; k < 4; k++) {
                    weight_gradients[i][j][k] = Vector::Zero();
                    weights[i][j][k] = 0.0;
                }
            }
        }
    }
    __host__ __device__ Particle(Vector x, Vector v, Precision rho_0, Precision particle_volume) { // napisac dodatkowy konstruktor z wektorami
        this->x = x;
        this->v = v;
        this->a = Vector::Zero();
        this->m = rho_0 * particle_volume;
        this->V = 0.0;
        this->rho = 0.0;
        this->Fe = Matrix::Identity();
        this->Fp = Matrix::Identity();
        this->velocity_gradient = Matrix::Zero();

        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                for (int k = 0; k < 4; k++) {
                    weight_gradients[i][j][k] = Vector::Zero();
                    weights[i][j][k] = 0.0;
                }
            }
        }
    }
};

#endif