#ifndef OBJ_LOADER_H
#define OBJ_LOADER_H

#include "common.cuh"
#include <vector>
#include <string>

// do tekstur, jakby byly potrzebne
// pewnie nie beda, wiec usune niedlugo
struct Vec2 {
    float u, v;
};

struct Triangle {
    int vertexIndices[3];
    int texcoordIndices[3]; // tekstury
    int normalIndices[3];
};

struct Mesh {
    std::vector<Vector> vertices;
    std::vector<Vec2> texcoords; // tekstury
    std::vector<Vector> normals;
    std::vector<Triangle> triangles;
};

// wczytywanie plikow obj
bool loadOBJ(const std::string& filename, Mesh& mesh);

// do wyznaczenia bounding box siatki
void bounding_box(const Mesh& mesh, Precision& x_min, Precision& y_min, Precision& z_min, Precision& x_max, Precision& y_max, Precision& z_max);

void renderOBJ(Mesh& mesh);

// iloczyn wektorowy
Vector cross(const Vector& a, const Vector& b);

// iloczyn skalarny
Precision dot(const Vector& a, const Vector& b);

// liczymy objetosc siatki
Precision calculateVolume(const Mesh& mesh);

// najwyrazniej nie bylo potrzebne
//// bounding box
//struct bbox {
//    Precision x_min, x_max, y_min, y_max, z_min, z_max;
//};

#endif